"use strict";
exports.__esModule = true;
var fetch_1 = require("../../../api/fetch");
// pages/components/FeedbackItem/FeedbackItem.ts
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        feedbackData: {
            type: Object,
            value: {
                areaId: 0,
                areaName: '',
                customerId: 0,
                customerName: '',
                customerPhone: '',
                customerSex: '',
                feedbackContent: '',
                id: 0,
                state: ''
            }
        }
    },
    /**
     * 组件的初始数据
     */
    data: {
        inputValue: ''
    },
    /**
     * 组件的方法列表
     */
    methods: {
        makePhoneCallHandle: function () {
            console.log('in makePhoneCallHandle');
            wx.makePhoneCall({
                phoneNumber: this.data.feedbackData.customerPhone,
                success: function () {
                    console.log('success');
                },
                fail: function () {
                    console.log('fail');
                }
            });
        },
        inputHandle: function (e) {
            var val = e.detail.value;
            this.setData({
                inputValue: val
            });
        },
        sendFeedback: function () {
            var _this = this;
            var val = this.data.inputValue;
            (0, fetch_1.customerFetch)({
                url: '/feedback/feedback',
                method: 'PUT',
                data: {
                    id: this.data.feedbackData.id,
                    replayContent: val,
                    state: '3'
                }
            })
                .then(function (res) {
                wx.showToast({
                    title: res.msg
                });
                _this.setData({
                    inputValue: ''
                });
                _this.triggerEvent('refresh', {});
            })["catch"](function (err) {
                wx.showToast({
                    title: err.errMsg,
                    icon: 'none'
                });
            });
        },
        goDetailPage: function () {
            console.log(this.data.feedbackData);
            wx.navigateTo({
                url: "/pages/feedbackDetail/feedbackDetail?customerName=".concat(this.data.feedbackData.customerName, "&customerPhone=").concat(this.data.feedbackData.customerPhone, "&id=").concat(this.data.feedbackData.id, "&areaId=").concat(this.data.feedbackData.areaId)
            });
        }
    }
});
