import { deviceFetch, baseFetch } from '../../api/fetch'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: [],
    pageSize: 20,
    pageNum: 1,
    total: 0,
    opName: '',
    operatorId: '',
    opList: [],
    opvalue: '',
    type: ""
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    //请求设备明细列表
    this.setData({
      operatorId: options.operatorId,
      opName: options.opName,
      type: options.type
    })
    if (options.type) {
      this.getData({ state: options.type, pageNum: this.data.pageNum, pageSize: this.data.pageSize, operatorId: options.operatorId })
    } else {
      this.getData({ pageNum: this.data.pageNum, pageSize: this.data.pageSize, operatorId: options.operatorId });
    }
  },
  onReachBottom() {
    console.error("我草",this.data.list.length,this.data.total)
    if (this.data.list.length >= this.data.total) {
      wx.showToast({
        title: '列表已加载完',
        icon: 'none'
      })
      return;
    } else {
      let pageNum = this.data.pageNum;
      this.getData({
        pageNum: pageNum + 1,
        pageSize: this.data.pageSize,
        state: this.data.type,
        operatorId: this.data.operatorId, 
        areaId: this.data.opvalue&&this.data.opvalue!='0' ? this.data.opList[this.data.opvalue].id : '' 
      })
    }
  },
  setArea(v) {
    console.log(v)
    let list = this.data.list;
    list.splice(0)
    this.setData({
      opvalue: v.detail.value,
      list:list
    });
    this.getData({ state: this.data.type, pageNum: 1, pageSize: this.data.pageSize, operatorId: this.data.operatorId, areaId: v.detail.value&&v.detail.value!='0' ? this.data.opList[v.detail.value].id : '' })
  },
  handleK(e) {
    let id = e.target.dataset.id;
    let type = e.target.dataset.type;
    let code = e.target.dataset.code;
    wx.showModal({
      title: '确认操作',
      content: '当前操作会将设备‘'+code + (type == 1 ? '’移除' : '’恢复') + '续费,确认继续吗？'
    }).then(res => {
      if (res.confirm) {
        if (type == 1) {
          this.remove(id);
        } else {
          this.recovery(id);
        }
      }
    })
  },
  recovery(id) {
    deviceFetch({
      url: `/deviceServiceFees/operators/devices/${id}/autoPayRecovery`,
      method: 'put'
    }).then(res => {
      wx.showToast({
        title: '恢复成功',
        icon: 'success'
      });
      let list = this.data.list;
      list.map(item => {
        if (item.id == id) {
          item.isAutoPay = 1
        }
      })
      this.setData({
        list: list
      })
    }).catch(err => {
      wx.showToast({
        title: err.errMsg,
        icon: 'none'
      })
    })
  },
  remove(id) {
    deviceFetch({
      url: `/deviceServiceFees/operators/devices/${id}/autoPayRemoving`,
      method: 'PUT'
    }).then(res => {
      console.error(res)
      wx.showToast({
        title: '移除成功',
        icon: 'success'
      });
      let list = this.data.list;
      list.map(item => {
        if (item.id == id) {
          item.isAutoPay = 0
        }
      })
      this.setData({
        list: list
      })
    }).catch(err => {
      wx.showToast({
        title: err.errMsg,
        icon: 'none'
      })
    })
  },
  setType(v) {
    console.error(v)
    if (v.currentTarget.dataset.type == this.data.type) {
      return;
    }
    let list = this.data.list;
    list.splice(0)
    this.setData({
      type: v.currentTarget.dataset.type,
      list: list,
      pageNum: 1,
      total: 0
    })
    if (v.currentTarget.dataset.type) {
      this.getData({ state: v.currentTarget.dataset.type, pageNum: 1, pageSize: this.data.pageSize, operatorId: this.data.operatorId, areaId: this.data.opvalue&&this.data.opvalue!='0' ? this.data.opList[this.data.opvalue].id : '' })
    } else {
      this.getData({ pageNum: 1, pageSize: this.data.pageSize, operatorId: this.data.operatorId, areaId:this.data.opvalue&&this.data.opvalue!='0' ? this.data.opList[this.data.opvalue].id:'' });
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    //获取区域列表
    baseFetch({
      url: '/dcxy/baseArea/queryAll',
      method: 'get'
    }).then(res => {
      let oplist = this.data.opList;
      oplist.push({areaName:'选择区域',id:0})
      oplist.push(...res.data)
      this.setData({
        opList: oplist
      })
    })
  },
  getData(entity) {
    deviceFetch({
      url: '/deviceServiceFees/operators/devices',
      method: 'GET',
      data: entity
    }).then(res => {
      let list = this.data.list;
      let total = res.data.total;
      let pageNum = res.data.pageNum;
      if (res.data.list&&res.data.list.length>0) {
        res.data.list.forEach(item => {
          let newT = item.expiresTime?item.expiresTime.slice(0, 10):'-';
          item.expiresTime = newT;
          list.push(item)
        })
      }
      this.setData({
        list: list,
        pageNum:pageNum,
        total: total
      });
    })
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },
  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  }
})